/*

	xchat-rot13.c
	
	Based on
	xchat-turnround.c
	-----------------
	by
	lamagra <access-granted@geocities.com>
        http://bounce.to/unah16
	
	and ssh patch from
	http://ucsub.colorado.edu/~kominek/rot13
	
	no copyright claims
	
	comments/patches to sick@irc.li 

*/

#define PLUGIN_NAME "rot13"
#define PLUGIN_DESC "poor encryption of chat traffic"

#ifdef PLUGIN_CHECK
#include <stdio.h>
#endif

#include <ctype.h>
#include <string.h>
#include "../../src/common/xchat.h"
#include "../../src/common/plugin.h"

/* globals */
extern struct module *module_find(char *name);
struct xp_signal chanmsg_sig;
char *name = PLUGIN_NAME;
char *desc = PLUGIN_DESC;

/* prototypes */
void turn(char *, char *);
int chanmsg (struct server *serv, char *from, char *ip, char *text, void *a, char c);
//(struct server *, char *, char *, char *, void *, char );

int (*chanmsg_next) (void *, void *, void *, void *, void *, char);


#ifdef PLUGIN_CHECK
/* main loop */
int main(int argc, char *argv[])
{
        char buf[1024];
        char s[] = "Checking leetspeak module\0";
 	
        printf(PLUGIN_NAME " (check)\n");
        leetize(buf, s);
        printf("> %s\n", s);
        printf("< %s\n", buf);
 	
        return 0;
}
#endif

#ifndef PLUGIN_CHECK
int module_init(int ver, struct module *mod, struct session *sess)
{
	if (ver != MODULE_IFACE_VER)
		return 1;
	
	if (module_find (name) != NULL)
	{
		PrintText(sess, "\0035      Module " PLUGIN_NAME " already loaded \003 \n");
		return 1;
	}
	PrintText(sess, "\0035      Loaded module " PLUGIN_NAME "\003 \n");
	mod->name = name;
	mod->desc = desc;
		
	chanmsg_sig.signal = XP_CHANMSG;
	chanmsg_sig.callback = XP_CALLBACK(chanmsg);
	chanmsg_sig.naddr = &chanmsg_next;
	chanmsg_sig.mod = mod;

	hook_signal(&chanmsg_sig);

	return 0;
}

void module_cleanup(struct module *mod, struct session *sess)
{
	PrintText(sess, "\0035      Unloaded module " PLUGIN_NAME "\003 \n");
}

int chanmsg(struct server *serv, char *from, char *ip, char *text, void *a, char c)
{
	struct	session	*sess;
	char	buf[512];
	
	sess = serv->front_session;
	
	memset(buf, 0, sizeof(buf));
	turn(buf, text);
	
	strcpy(text, buf);
	
	XP_CALLNEXT(chanmsg_next, serv, from, ip, text, a, c);
}

#endif

void turn(char *dest, char *src)
{
unsigned int len;
len=strlen(src);
  while(len--) {
    if((*src>='a')&&(*src<='m')) *dest=(*src)+13;
    else if((*src>='n')&&(*src<='z')) *dest=(*src)-13;
    else if((*src>='A')&&(*src<='M')) *dest=(*src)+13;
    else if((*src>='N')&&(*src<='Z')) *dest=(*src)-13;
    else *dest=*src;
    dest++, src++; };
}
